# calculate all unique! divider

# import
import matplotlib.pyplot as plot
from math import log

# constants
N = 10**8
SCALE = 1000

# calculate
teiler = [0 for i in range(0, N)]

for i in range(2, N):
    if not teiler[i]:
        for j in range(i, N, i):
            teiler[j] += 1

    if i % (N / 10) == 0:
        print('.', end='')

# count per interval
x_axis = range(0, N, int(N/SCALE))
counter = [[0 for i in x_axis] for i in range(10)]
interval = -1

for i in range(0, N):
    interval = int(i / (N/SCALE))
    t = teiler[i]
    counter[t][interval] += 1

# prepare visual
ax = plot.figure().add_subplot(111)
ax.set_xlim([0, N])
ax.set_ylim([0, 4])

ax.set_xlabel('n')
ax.set_ylabel('Durchschnittliches $\omega$ für ein Intervall')

mean = []
log_data = []

for i, x in enumerate(x_axis):
    s = 0
    d = 0
    for c in range(1, 10):
        s += counter[c][i] * c
        d += 1
    mean.append(s/(N/SCALE))
    if x == 0:
        log_data.append(0)
    else:
        log_data.append(log(log(x)))


ax.plot(x_axis, mean, '-')
ax.plot(x_axis, log_data, '-')
        

plot.show()
